//TMBI System - Too Many Bricks Inventory System
//--------------------
//By Nexus 4833
//====================

$tmbi::version = "2.51 FULL";

function tmbi_debug(%msg)
{
	if($tmbi::debug)
		echo("DEBUG: "@ %msg);
}

//x and y are both row numbers, but y ignores hidden rows, used for rendering.
function tmbi_generatenewinvrow(%x, %y)
{
	if(%x == getword($tmbi::current, 0))
		%color = getwords($tmbi::pref::color2, 0, 1) SPC getword($tmbi::pref::color2, 2)+((1-getword($tmbi::pref::color2, 2))*0.3) SPC getword($tmbi::pref::color2, 3)*(96/255); // 0 0 100 96
	else
		%color = getwords($tmbi::pref::color2, 0, 2) SPC getword($tmbi::pref::color2, 3)*(64/255);
	%row = new GuiSwatchCtrl("TMBI_ROW_"@%x)
	{
		profile = "HUDBitmapProfile";
		horizSizing = "center";
		vertSizing = "bottom";
		position = "0" SPC 66*%y;
		extent = "640 64";
		minExtent = "8 2";
		visible = "1";
		color = "0 0 0 0";
	};
	%row.setcolor(%color); //so I don't need to do a dumb 255 conversion thing

	for(%a=0; %a<10; %a++)
	{
		%b = new GuiSwatchCtrl()
		{
			profile = "HUDBitmapProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = (2 + 64*%a) SPC "4";
			extent = "60 56";
			minExtent = "8 2";
			visible = "1";
			color = "0 0 0 0";
		};
		%b.setcolor(getwords($tmbi::pref::color2, 0, 2) SPC getword($tmbi::pref::color2, 3)*(64/255));
		%d = new GuiBitmapCtrl("TMBI_ACTIVESLOT_"@%x@"_"@%a)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = 64*%a SPC "0";
			extent = "64 64";
			minExtent = "8 2";
			visible = $tmbi::current $= (%x SPC %a);
			bitmap = "base/client/ui/brickicons/brickIconActive";
			wrap = "0";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "1";
		};

		if($tmbi::brick[%x, %a] $= "")
			%val = "";
		else if(!isobject($tmbi::brick[%x, %a]) || ($uinametable[$tmbi::brick[%x, %a].uiname] !$= $tmbi::brick[%x, %a])) //housekeeping
		{
			$tmbi:brick[%x, %a] = "";
			%val = "";
		}
		else if($tmbi::brick[%x, %a].iconname $= "")
			%val = "base/client/ui/brickIcons/Unknown";
		else
			%val = $tmbi::brick[%x, %a].iconname;
		%c = new GuiBitmapCtrl("TMBI_SLOT_"@%x@"_"@%a)
		{
			profile = "HUDBitmapProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = 64*%a SPC "0";
			extent = "64 64";
			minExtent = "8 2";
			visible = "1";
			bitmap = %val;
		};

		if($pref::Hud::RecolorBrickIcons)
		{
			%color = getcoloridtable($currSprayCanIndex);
			%colorA = 1-((1-getword(%color, 3))*$tmbi::pref::transweight); //on a diet, weighs less
			%c.setcolor(getwords(%color, 0, 2) SPC %colorA);
		}

		if(%a == 9)
			%text = "0";
		else
			%text = %a+1;
		%e = new GuiMLTextCtrl("TMBI_INVTEXT_"@%x@"_"@%a)
		{
			profile = "GuiMLTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = 64*%a SPC "2";
			extent = "20 18";
			minExtent = "8 2";
			visible = (getword($tmbi::current, 0) == %x);
			lineSpacing = "2";
			allowColorChars = "0";
			maxChars = "-1";
			text = "<just:center><color:"@tmbi_coltohex($tmbi::pref::color1)@"><font:"@ $tmbi::pref::font @":18>"@ %text;
			maxBitmapHeight = "-1";
			selectable = "1";
		};
		%row.add(%b);
		%row.add(%d);
		%row.add(%c);
		%row.add(%e);
	}
	return %row;
}

//builds row in the brick selector
function tmbi_generatenewselrow(%x) //Next row pos [0 63] compared to last one
{
	%row = new GuiSwatchCtrl("TMBI_SELROW_"@%x)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "0" SPC 63*%x;
		extent = "617 61";
		minExtent = "8 2";
		visible = "1";
		color = "130 130 230 255";
	};

	//each row gets 3 buttons
	for(%i=0; %i<3; %i++)
	{
		if(%i == 0)
			%text = "Hide";
		else if(%i == 1)
			%text = "Clear";
		else
			%text = "Remove";
		%gui = new GuiBitmapButtonCtrl()
		{
			profile = "BlockButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "3" SPC 3 + 18*%i;
			extent = "48 18";
			minExtent = "8 2";
			visible = "1";
			command = "tmbi_"@ %text @"row("@ %x @");";
			accelerator = "";
			text = %text;
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "base/client/ui/button1";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "0 0 0 0";
		};
		%gui.setcolor($tmbi::pref::color0);
		%row.add(%gui);
	}
	%gui = new GuiSwatchCtrl()
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "54 3";
		extent = "559 55";
		minExtent = "8 2";
		visible = "1";
		color = "51 128 255 255";
	};

	//inv slots
	for(%i=0; %i<10; %i++)
	{
		%a = new GuiBitmapCtrl()
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = 56*%i SPC "0";
			extent = "55 55";
			minExtent = "8 2";
			visible = "1";
			bitmap = "base/client/ui/brickicons/brickiconbg";
			wrap = "0";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "1";
		};

		if($tmbi::selbrick[%x, %i] $= "")
			%val = "";
		else if(!isobject($tmbi::selbrick[%x, %i]) || ($uinametable[$tmbi::selbrick[%x, %i].uiname] != $tmbi::selbrick[%x, %i])) //housekeeping
		{
			$tmbi:selbrick[%x, %i] = "";
			%val = "";
		}
		else if($tmbi::selbrick[%x, %i].iconname $= "")
			%val = "base/client/ui/brickIcons/Unknown";
		else
			%val = $tmbi::selbrick[%x, %i].iconname;
		%b = new GuiBitmapCtrl("TMBI_SELICON_"@ %x @"_"@ %i)
		{
			profile = "HUDBitmapProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = 56*%i SPC "0";
			extent = "55 55";
			minExtent = "8 2";
			visible = "1";
			bitmap = %val; //Datablock.iconname, default is base/client/ui/brickIcons/Unknown
			wrap = "0";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "1";
		};
		%c = new GuiBitmapCtrl("TMBI_SELACTIVE_"@ %x @"_"@ %i)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = 56*%i SPC "0";
			extent = "55 55";
			minExtent = "8 2";
			visible = $tmbi::selinvbrick $= (%x SPC %i);
			bitmap = "base/client/ui/brickicons/brickIconActive";
			wrap = "0";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "1";
		};
		%d = new GuiBitmapButtonCtrl()
		{
			profile = "BlockButtonProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = 56*%i SPC "0";
			extent = "55 55";
			minExtent = "8 2";
			visible = "1";
			command = "tmbi_selectinv("@ %x @","@ %i @");";
			text = " ";
			groupNum = "-1";
			buttonType = "PushButton";
			bitmap = "base/client/ui/brickicons/brickIconBtn";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			mKeepCached = "0";
			mColor = "255 255 255 255";
		};
		%gui.add(%a);
		%gui.add(%b);
		%gui.add(%c);
		%gui.add(%d);
	}
	%row.add(%gui);
	%gui = new GuiSwatchCtrl("TMBI_SELROWHIDDEN_"@ %x)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "54 3";
		extent = "559 55";
		minExtent = "8 2";
		visible = $tmbi::selhiddenrow[%x];
		color = "0 0 0 150";
	};
	%row.add(%gui);
	return %row;
}

function tmbi_toggle()
{
	if($BuildingDisabled)
	{
		if(!$tmbi::repurposekeybinds)
			clientcmdcenterprint("\c6Building is currently disabled.", 4);

		if(!$tmbi::open)
			return;
	}

	if($tmbi::open)
	{
		commandtoserver('unusetool');
		$tmbi::open = 0;
		tmbi_deactivatekeybind();
	}
	else
	{
		if(!tmbi_gotbricks())
		{
			if(!$tmbi::repurposekeybinds)
				clientcmdcenterprint("\c6You have no bricks in your inventory.", 2);
			return;
		}
		setscrollmode($SCROLLMODE_BRICKS);
		tmbi_activatekeybind();
		$tmbi::open = 1;
		$tmbi::scrollblockers = "";
	}
	tmbi_update();
}

//tmbi intercepts the lcontrol key for vertical scrolling
function tmbi_activatekeybind()
{
	tmbi_debug("activating keybind");
	movemap.bind(keyboard, lcontrol, tmbi_control);
}

function tmbi_deactivatekeybind()
{
	tmbi_debug("deactivating keybind");
	if(isfunction($tmbi::prevctrl))
		movemap.bind(keyboard, lcontrol, $tmbi::prevctrl);
	else
		movemap.bind(keyboard, lcontrol, ""); //so it doesn't show up as a non-remappable command
}

//going to the right in the HUD inventory.  Only used when 'Uxie' pref is disabled
function tmbi_right() //looks good
{
	if(!$tmbi::open)
	{
		if(!tmbi_gotbricks())
		{
			clientcmdcenterprint("\c6You have no bricks in your inventory.", 2);
			return;
		}
		tmbi_toggle();
	}
	tmbi_debug("passed open test");
	%a = getword($tmbi::current, 0);
	%b = getword($tmbi::current, 1);

	if(!tmbi_isint(%a))
		%a = 0;
	if(!tmbi_isint(%b))
		%b = 0;
	$tmbi::current = %a SPC %b;
	tmbi_debug("current: " @ $tmbi::current);
	%init = true;

	while($tmbi::brick[%a, %b] $= "" || %init)
	{
		tmbi_debug("entering main while block: "@%b);

		if(%init)
			%init = false;
		%b++;

		if(%b > 9)
		{
			%b = 0;

			if($tmbi::pref::nextscroll)
			{
				%safe = %a;
				%initb = true;

				while($tmbi::hiddenrow[%a] || %initb)
				{
					tmbi_debug("entering secondary while block: "@%a);
					if(%initb)
						%initb = false;
					%a++;

					if(%a >= $tmbi::rowcount)
						%a = 0;

					//shouldn't be needed, but I like retard-proofing
					if(%a == %safe)
						break;
				}
			}
		}

		if((%a SPC %b) $= $tmbi::current)
			return;

		if(!$tmbi::pref::nextscroll)
		{
			tmbi_debug("uxie is mad, bailing...");
			break;
		}
	}
	tmbi_setcurrent(%a SPC %b);
	//$tmbi::current = %a SPC %b;
	tmbi_debug("exiting: "@ $tmbi::current);
	//tmbi_update();
}

function tmbi_left() //looks good
{
	if(!$tmbi::open)
	{
		if(!tmbi_gotbricks())
		{
			clientcmdcenterprint("\c6You have no bricks in your inventory.", 2);
			return;
		}
		tmbi_toggle();
	}
	tmbi_debug("passed open test");
	%a = getword($tmbi::current, 0);
	%b = getword($tmbi::current, 1);

	if(!tmbi_isint(%a))
		%a = 0;
	if(!tmbi_isint(%b))
		%b = 0;
	$tmbi::current = %a SPC %b;
	tmbi_debug("current: " @ $tmbi::current);
	%init = true;

	while($tmbi::brick[%a, %b] $= "" || %init)
	{
		tmbi_debug("entering main while block: "@%b);
		if(%init)
			%init = false;
		%b--;

		if(%b < 0)
		{
			%b = 9;

			if($tmbi::pref::nextscroll)
			{
				%safe = %a;
				%initb = true;

				while($tmbi::hiddenrow[%a] || %initb)
				{
					tmbi_debug("entering secondary while block: "@%a);
					if(%initb)
						%initb = false;
					%a--;

					if(%a < 0)
						%a = $tmbi::rowcount-1;

					//shouldn't be needed, but I like retard-proofing
					if(%a == %safe)
						break;
				}
			}
		}

		if((%a SPC %b) $= $tmbi::current)
			return;

		if(!$tmbi::pref::nextscroll)
		{
			tmbi_debug("uxie is mad, bailing...");
			break;
		}
	}
	tmbi_setcurrent(%a SPC %b);
	//$tmbi::current = %a SPC %b;
	tmbi_debug("exiting: "@ $tmbi::current);
	//tmbi_update();
}

function tmbi_down()
{
	if(!$tmbi::open)
	{
		if(!tmbi_gotbricks())
		{
			clientcmdcenterprint("\c6You have no bricks in your inventory.", 2);
			return;
		}
		tmbi_toggle();
	}
	tmbi_debug("passed open test");
	%a = getword($tmbi::current, 0);
	%b = getword($tmbi::current, 1);

	if(!tmbi_isint(%a))
		%a = 0;
	if(!tmbi_isint(%b))
		%b = 0;
	$tmbi::current = %a SPC %b;
	tmbi_debug("current: " @ $tmbi::current);
	%bypass = true;
	%bypassb = true;
	%safe = %a;
	%c = 0;
	%d = %b;

	while($tmbi::brick[%a, %b] $= "" || %bypass)
	{
		tmbi_debug("entering main loop: "@ %b SPC %c);

		if(%bypass)
			%bypass = false;
		else
		{
			//this looks sketchy, basically it is alternating looking left and right to find nearest brick
			%c*=-1;

			if(%c >= 0)
				%c++; //alternating magic

			if(mabs(%c) > 10)
			{
				%c = 0;
				%bypassb = true;
				%b = %d;
			}
			else
				%b = %d + %c;
		}

		while($tmbi::hiddenrow[%a] || %bypassb)
		{
			tmbi_debug("entering secondary loop: "@ %a);

			if(%bypassb)
				%bypassb = false;
			%a++; //0 is top

			if(%a >= $tmbi::rowcount)
				%a = 0;

			if(%a == %safe)
				break;
		}

		if((%a SPC %b) $= $tmbi::current)
		{
			tmbi_debug("well that didn't work...");
			tmbi_left();
			return;
		}

		if(!$tmbi::pref::nextscroll)
		{
			tmbi_debug("uxie is mad, bailing...");
			break;
		}
	}
	tmbi_setcurrent(%a SPC %b);
	//$tmbi::current = %a SPC %b;
	tmbi_debug("exiting: "@ $tmbi::current);
	//tmbi_update();
}

function tmbi_up()
{
	if(!$tmbi::open)
	{
		if(!tmbi_gotbricks())
		{
			clientcmdcenterprint("\c6You have no bricks in your inventory.", 2);
			return;
		}
		tmbi_toggle();
	}
	tmbi_debug("passed open test");
	%a = getword($tmbi::current, 0);
	%b = getword($tmbi::current, 1);

	if(!tmbi_isint(%a))
		%a = 0;
	if(!tmbi_isint(%b))
		%b = 0;
	$tmbi::current = %a SPC %b;
	tmbi_debug("current: " @ $tmbi::current);
	%bypass = true;
	%bypassb = true;
	%safe = %a;
	%c = 0;
	%d = %b;

	while($tmbi::brick[%a, %b] $= "" || %bypass)
	{
		tmbi_debug("entering main loop: "@ %b SPC %c);

		if(%bypass)
			%bypass = false;
		else
		{
			%c*=-1;

			if(%c >= 0)
				%c++; //alternating magic

			if(mabs(%c) > 10)
			{
				%c = 0;
				%bypassb = true;
				%b = %d;
			}
			else
				%b = %d + %c;
		}

		while($tmbi::hiddenrow[%a] || %bypassb)
		{
			tmbi_debug("entering secondary loop: "@ %a);

			if(%bypassb)
				%bypassb = false;
			%a--; //0 is top

			if(%a < 0)
				%a = $tmbi::rowcount-1;

			if(%a == %safe)
				break;
		}

		if((%a SPC %b) $= $tmbi::current)
		{
			tmbi_debug("well that didn't work...");
			tmbi_right();
			return;
		}

		if(!$tmbi::pref::nextscroll)
		{
			tmbi_debug("uxie is mad, bailing...");
			break;
		}
	}
	tmbi_setcurrent(%a SPC %b);
	//$tmbi::current = %a SPC %b;
	tmbi_debug("exiting: "@ $tmbi::current);
	//tmbi_update();
}

//click a brick in the shop
function tmbi_selectbrick(%x)
{
	if($tmbi::selshopbrick !$= "")
		$BSD_activeBitmap[$tmbi::selshopbrick].setvisible(0);

	if($tmbi::selinvbrick !$= "")
	{
		$tmbi::selbrick[getword($tmbi::selinvbrick,0), getword($tmbi::selinvbrick,1)] = %x;
		$tmbi::selinvbrick = "";
		$tmbi::selshopbrick = ""; //just to be safe or something I dunno
		$tmbi::lastselshopbrick = "";
	}
	else
	{
		if($tmbi::lastselshopbrick == %x && getsimtime() - $tmbi::selshopclicktime < 500)
		{
			//double click
			//force brick into inventory

			for(%a=0; %a<$tmbi::selrowcount; %a++) //hobo moving into an empty box
			{
				if(!$tmbi::selhiddenrow[%a])
				{
					for(%b=0; %b<10; %b++)
					{
						if($tmbi::selbrick[%a, %b] $= "")
						{
							%found = true;
							break;
						}
					}

					if(%found)
						break; //I wish torque had a double break thingy
				}
			}

			if(!%found) //shove them out of the way like a boss
			{
				%firstbrick = true;

				for(%a=$tmbi::selrowcount-1; %a>=0; %a--)
				{
					if(!$tmbi::selhiddenrow[%a])
					{
						for(%b=9; %b>=0; %b--)
						{
							if(%firstbrick)
							{
								%lastbrick = $tmbi::selbrick[%a, %b];
								%firstbrick = false;
							}
							else
							{
								%thisbrick = $tmbi::selbrick[%a, %b];
								$tmbi::selbrick[%a, %b] = %lastbrick;
								%lastbrick = %thisbrick;
							}
						}
					}
				}
				%a = $tmbi::selrowcount-1;
				%b = 9;
			}
			$tmbi::selbrick[%a, %b] = %x;
			$tmbi::selshopbrick = "";
			$tmbi::lastselshopbrick = "";
		}
		else //togglol
		{
			if($tmbi::selshopbrick == %x)
				$tmbi::selshopbrick = "";
			else
				$tmbi::selshopbrick = %x;
			$tmbi::lastselshopbrick = %x;
		}
	}
	$tmbi::selshopclicktime = getsimtime();
	tmbi_updatesel();
}

function tmbi_selectinv(%row, %x)
{
	if($tmbi::selshopbrick !$= "")
		$BSD_activeBitmap[$tmbi::selshopbrick].setvisible(0);

	if($tmbi::selshopbrick)
	{
		$tmbi::selbrick[%row, %x] = $tmbi::selshopbrick;
		$tmbi::selshopbrick = ""; //just to be safe
		$tmbi::selinvbrick = "";
		%val = 1;
	}
	else
	{
		if($tmbi::lastselinvbrick $= (%row SPC %x) && getsimtime() - $tmbi::selinvclicktime < 500) //those parentheses are really gay imo
		{
			$tmbi::selbrick[%row, %x] = "";
			$tmbi::selinvbrick = "";
			%val = 1;
		}
		else
		{
			if($tmbi::selinvbrick !$= "")
			{
				if($tmbi::selinvbrick $= (%row SPC %x))
					$tmbi::selinvbrick = "";
				else
				{
					if($tmbi::selbrick[getword($tmbi::selinvbrick,0), getword($tmbi::selinvbrick,1)] == $tmbi::selbrick[%row, %x])
						$tmbi::selinvbrick = %row SPC %x;
					else
					{
						%temp = $tmbi::selbrick[%row, %x];
						$tmbi::selbrick[%row, %x] = $tmbi::selbrick[getword($tmbi::selinvbrick,0), getword($tmbi::selinvbrick,1)];
						$tmbi::selbrick[getword($tmbi::selinvbrick,0), getword($tmbi::selinvbrick,1)] = %temp;
						$tmbi::selinvbrick = "";
						%val = 1;
					}
				}
			}
			else
				$tmbi::selinvbrick = %row SPC %x;
		}
	}
	if(%val)
		$tmbi::lastselinvbrick = "";
	else
		$tmbi::lastselinvbrick = %row SPC %x;
	$tmbi::selinvclicktime = getsimtime();
	tmbi_updatesel();
}

function tmbi_addrow() //looks good
{
	if(!tmbi_isint(%x = $tmbi::pref::maxrowcount))
		%x = 5;
	if($tmbi::selrowcount >= %x)
		return;
	$tmbi::selrowcount++;
	tmbi_updatesel();
}

function tmbi_removerow(%x) //looks good
{
	if($tmbi::selrowcount == 1)
		return;

	for(%a=%x; %a<$tmbi::selrowcount; %a++)
	{
		$tmbi::selhiddenrow[%a] = $tmbi::selhiddenrow[%a+1];

		for(%b=0; %b<10; %b++)
			$tmbi::selbrick[%a, %b] = $tmbi::selbrick[%a+1, %b];
	}
	$tmbi::selrowcount--;
	tmbi_updatesel();
}

function tmbi_hiderow(%x) //looks good
{
	$tmbi::selhiddenrow[%x] = !$tmbi::selhiddenrow[%x];
	("TMBI_SELROWHIDDEN_"@ %x).setvisible($tmbi::selhiddenrow[%x]); //I reversed hiddenrow and rowhidden just to confuse myself for shits and giggles
	for(%a=0; %a<10; %a++)
	{
		if($tmbi::selinvbrick $= (%x SPC %a))
			$tmbi::selinvbrick = "";
	}
}

function tmbi_clearcart() //looks good
{
	for(%a=0; %a<$tmbi::selrowcount; %a++)
	{
		$tmbi::selhiddenrow[%a] = "";
		tmbi_clearrow(%a);
	}
	$tmbi::selrowcount = 1;
	tmbi_updatesel();
}

function tmbi_clearrow(%x) //looks good
{
	for(%a=0; %a<10; %a++)
	{
		$tmbi::selbrick[%x, %a] = "";

		if($tmbi::selinvbrick $= (%x SPC %a))
			$tmbi::selinvbrick = "";
	}
	tmbi_updatesel();
}

function tmbi_clickfav(%x) //SHIT UI NAME VERSUS DATABLOCK
{
	if(BSD_FavsHelper.visible)
	{
		//play nice
		exec("config/client/Favorites.cs");

		for(%a=0; %a<10; %a++)
			$Favorite::Brick[%x, %a] = $tmbi::selbrick0_[%a].uiname;
		export("$Favorite::Brick*", "config/client/Favorites.cs");

		//now for the real fun
		if(isfile(%path = "config/client/TMBI/favs.cs"))
			exec(%path);

		for(%a=0; %a<$tmbi::favorite::rowcount[%x]; %a++) //good practice
		{
			for(%b=0; %b<10; %b++)
				$tmbi::favorite::brick[%x, %a, %b] = "";
			$tmbi::favorite::hiddenrow[%a] = "";
		}

		for(%a=0; %a<$tmbi::selrowcount; %a++)
		{
			$tmbi::favorite::hiddenrow[%x, %a] = $tmbi::selhiddenrow[%a];

			for(%b=0; %b<10; %b++)
			{
				if(($tmbi::favorite::brick[%x, %a, %b] = $tmbi::selbrick[%a, %b].uiname) !$= "")
					%gat = true;
			}
		}
		$tmbi::favorite::rowcount[%x] = $tmbi::selrowcount;
		export("$tmbi::favorite::*", "config/client/TMBI/favs.cs");

		if(!%gat) //have a better way? stick it up your butt
			(BSD_FavButton @ %x).mcolor = "255 255 255 128";
		else
			(BSD_FavButton @ %x).mcolor = "255 255 255 255";
		BSD_SetFavs();
	}
	else
	{
		tmbi_clearcart();
		$tmbi::favorite::rowcount[%x] = "";

		if(isfile("config/client/TMBI/favs.cs"))
			exec("config/client/TMBI/favs.cs");

		if($tmbi::favorite::rowcount[%x])
		{
			$tmbi::selrowcount = $tmbi::favorite::rowcount[%x];

			for(%a=0; %a<$tmbi::selrowcount; %a++)
			{
				$tmbi::selhiddenrow[%a] = $tmbi::favorite::hiddenrow[%x, %a];

				for(%b=0; %b<10; %b++)
					$tmbi::selbrick[%a, %b] = $uinametable[$tmbi::favorite::brick[%x, %a, %b]];
			}
		}
		else
		{
			//in case of pfft
			exec("config/client/Favorites.cs");

			for(%a=0; %a<10; %a++)
				$tmbi::selbrick0_[%a] = $uinametable[$Favorite::Brick[%x, %a]];
			$tmbi::selrowcount = 1;
		}
		tmbi_updatesel();
	}
}

function tmbi_setinventorydata()
{
	for(%a=0; %a<$tmbi::rowcount; %a++) //housekeeping
	{
		for(%b=0; %b<10; %b++)
			$tmbi::brick[%a, %b] = "";
		$tmbi::hiddenrow[%a] = "";
	}

	for(%a=0; %a<$tmbi::selrowcount; %a++)
	{
		for(%b=0; %b<10; %b++)
			$tmbi::brick[%a, %b] = $tmbi::selbrick[%a, %b];

		if($tmbi::repurposekeybinds)
		{
			if(%a == 0)
			{
				for(%b=0; %b<10; %b++)
					commandtoserver('buybrick', %b, $tmbi::brick[0, %b]);
				%x = 0;
			}
			else
				%x = 1;
			$tmbi::hiddenrow[%a] = %x;
		}
		else
			$tmbi::hiddenrow[%a] = $tmbi::selhiddenrow[%a];
	}
	$tmbi::rowcount = $tmbi::selrowcount;
}

function tmbi_clickdone() //looks good
{
	tmbi_setinventorydata();

	if(!tmbi_gotbricks())
		$tmbi::wasopen = false;
	canvas.popdialog(BrickSelectorDlg);
}

function tmbi_closebsd()
{
	canvas.popdialog(BrickSelectorDlg);
}

function tmbi_openbsd() //NEEDS TO RETURN WHEN LOADING
{
	if(!playgui.isawake())
		return;

	if(!brickselectordlg.isawake())
	{
		if($BuildingDisabled)
		{
			clientcmdcenterprint("\c6Building is currently disabled.", 4);
			return;
		}

		if($tmbi::open)
		{
			$tmbi::wasopen = true;
			tmbi_toggle();
		}

		if($tmbi::selshopbrick !$= "")
		{
			$BSD_activeBitmap[$tmbi::selshopbrick].setvisible(0);
			$tmbi::selshopbrick = "";
		}
		$tmbi::selinvbrick = "";
		canvas.pushdialog(brickselectordlg);
	}
	else
		tmbi_clickdone();
}

function tmbi_clickcancel()
{
	canvas.popdialog(BrickSelectorDlg);
}

function tmbi_usebrick(%row, %slot)
{
	if($tmbi::repurposekeybinds)
	{
		commandtoserver('useinventory', %slot);
	}
	else
		commandtoserver('instantusebrick', $tmbi::brick[%row, %slot]);

	if($RecordingBuildMacro)
	{
		if($tmbi::repurposekeybinds)
			$BuildMacroSO.event[$BuildMacroSO.numEvents] = "Server\tUseInventory\t"@ %slot;
		else
			$BuildMacroSO.event[$BuildMacroSO.numEvents] = "Server\tInstantUseBrick\t"@ $tmbi::brick[%row, %slot]; //yay compatibility
		$BuildMacroSO.numEvents++;
	}
}

//clicking the button
function tmbi_reset()
{
	tmbi_clearcart();
	$tmbi::selrowcount = $tmbi::rowcount;

	for(%a=0; %a<$tmbi::rowcount; %a++)
	{
		$tmbi::selhiddenrow[%a] = $tmbi::hiddenrow[%a];

		for(%b=0; %b<10; %b++)
			$tmbi::selbrick[%a, %b] = $tmbi::brick[%a, %b];
	}

	if(!$tmbi::selrowcount)
		$tmbi::selrowcount = 1;
	tmbi_updatesel();
}

function tmbi_control(%x) //all keybinds should work like this
{
	$tmbi_control = %x;
}

//the main script to interface system, quite inefficient, but extremely versatile
function tmbi_updatesel()
{
	if(!isobject(tmbi_sellist))
		return;

//	if(isobject(TMBI_Resizer))
//	{
//		$tmbi::resizerpos = TMBI_Resizer.getposition();
//		TMBI_Resizer.delete();
//	}
	tmbi_sellist.clear();

	if(!$tmbi::selrowcount)
		%var = 0;
	else
		%var = 63*$tmbi::selrowcount - 2;

	if(%var != getword(tmbi_sellist.getextent(), 1))
		tmbi_sellist.resize(1, getword(tmbi_sellist.getposition(), 1), 617, %var);

	for(%a=0; %a<$tmbi::selrowcount; %a++)
	{
		%row = tmbi_generatenewselrow(%a);
		//do anything at all?

		tmbi_sellist.add(%row);
	}

	if($tmbi::selshopbrick !$= "")
		$BSD_activeBitmap[$tmbi::selshopbrick].setvisible(1);
	TMBI_TEXTDISPLAY.settext($tmbi::selbrick[getword($tmbi::selinvbrick,0), getword($tmbi::selinvbrick,1)].uiname);

	//resizer went here

	for(%i=1; %i<=7; %i++)
		eval("tmbi_btn"@%i@".setcolor(\""@$tmbi::pref::color0@"\");"); //bleh
}

//Bad to rely on this slow function too much, offload simpler updates to faster functions
//Completely rebuilds the inventory
function tmbi_update()
{
	tmbi_debug("updating...");
	if(!isobject(TMBI_MainInventory))
	{
		tmbi_activateinventory();
		return;
	}
	HUD_BrickNameBG.setvisible(0); //because deleting is mean
	HUD_BrickBox.setvisible(0);
	TMBI_MainInventory.setvisible(1);

	if($tmbi::current $= "")
		$tmbi::current = "0 0";

	if($tmbi::open || (!$pref::HUD::HideBrickBox && tmbi_gotbricks()))
	{
		if(!isobject(tmbi_inv_list))
			return;
		tmbi_inv_list.clear();

		if(tmbi_gotbricks())
		{
			%b=0;

			for(%a=0; %a<$tmbi::rowcount; %a++)
			{
				if(!$tmbi::hiddenrow[%a])
				{
					%row = tmbi_generatenewinvrow(%a, %b);
					tmbi_inv_list.add(%row);

					if(%a == getword($tmbi::current, 0))
					{
						for(%c=0; %c<10; %c++)
							$BSD_InvData[%c] = $tmbi::brick[%a, %c];
						%current = %b;
					}
					%b++;
				}
			}

			if(%current $= "")
			{
				tmbi_debug("problem syncing inventory row, trying again...");
				tmbi_up();
				return;
			}

			if($tmbi::brick[getword($tmbi::current,0), getword($tmbi::current,1)] $= "")
			{
				if($tmbi::pref::nextscroll)
				{
					tmbi_debug("problem syncing inventory, trying again...");
					tmbi_right();
					return;
				}
			}
			//else
			//	$tmbi::currdtb = $tmbi::brick[getword($tmbi::current,0), getword($tmbi::current,1)];
			%invheight = %b*66 - 2;
			tmbi_transition.setvisible(0);

			if(%invheight+16 > $tmbi::pref::height)
			{
				if($tmbi::pref::fadeinventory)
					tmbi_transition.setvisible(1);
				%height = $tmbi::pref::height;
			}
			else
				%height = %invheight + 16;
			tmbi_debug(%invpos SPC %invheight SPC %height);
			%invpos = %height/2 - 66*%current - 40; //yay math
			tmbi_debug(%invpos SPC %invheight SPC %height);

			if(%invpos > 0)
				%invpos = 0;
			%invpos += 8*tmbi_transition.isvisible();
			tmbi_debug(%invpos SPC %invheight SPC %height);

			if(%invpos*-1 + %height - 16 > %invheight)
				%invpos = %height - %invheight - 16;
			tmbi_debug(%invpos SPC %invheight SPC %height);
			tmbi_scroll_area.resize(0, 16, 640, %height-16);
			tmbi_inv_list.resize(0, %invpos, 640, %invheight);

			if(!$tmbi_instantusing)
				tmbi_usebrick(getword($tmbi::current,0), getword($tmbi::current,1));
			tmbi_UINAME.settext("<color:"@tmbi_coltohex($tmbi::pref::color1)@"><font:"@ $tmbi::pref::font @":16><just:center>"@ $tmbi::brick[getword($tmbi::current,0), getword($tmbi::current,1)].uiname);
		}
		else
		{
			tmbi_toggle();
			return;
		}
	}
	else
	{
		if($pref::HUD::showToolTips)
			%height = 16;
		else
			%height = 0;
		tmbi_UINAME.settext("<color:"@tmbi_coltohex($tmbi::pref::color1)@"><font:"@ $tmbi::pref::font @":16><just:center>Too Many Bricks Inventory");
	}
	TMBI_MainInventory.resize((getword(playgui.getextent(),0)-640)/2, getword(playgui.getextent(),1)-%height, 640, %height);

	if(%height > 82)
		%btmpos = %height + 57;
	else
		%btmpos = 139;
	%btmpos = getword(playgui.getextent(), 1) - %btmpos;
	bottomPrintDlg.resize((getword(playgui.getextent(), 0)-619)/2, %btmpos, 619, 145);
	tmbi_barthing.setcolor($tmbi::pref::color2);
	tmbi_transition.setcolor($tmbi::pref::color2);
	tmbi_debug("completed update");
}

function tmbi_setcurrent(%new)
{
	%old = $tmbi::current;
	(TMBI_ACTIVESLOT_ @ getword(%old, 0) @ "_" @ getword(%old, 1)).setvisible(0);
	(TMBI_ACTIVESLOT_ @ getword(%new, 0) @ "_" @ getword(%new, 1)).setvisible(1);
	$tmbi::current = %new;

	(TMBI_ROW_@ getword(%old, 0)).setcolor(getwords($tmbi::pref::color2, 0, 2) SPC getword($tmbi::pref::color2, 3)*(64/255));
	(TMBI_ROW_@ getword(%new, 0)).setcolor(getwords($tmbi::pref::color2, 0, 1) SPC getword($tmbi::pref::color2, 2)+((1-getword($tmbi::pref::color2, 2))*0.3) SPC getword($tmbi::pref::color2, 3)*(96/255)); // 0 0 100 96

	for(%i=0; %i<10; %i++)
	{
		(TMBI_INVTEXT_ @ getword(%old, 0) @ "_" @ %i).setvisible(0);
		(TMBI_INVTEXT_ @ getword(%new, 0) @ "_" @ %i).setvisible(1);
	}
	//necessary to count rows to see which ones are hidden
	%b = 0;

	for(%a=0; %a<$tmbi::rowcount; %a++)
	{
		if($tmbi::hiddenrow[%a])
			continue;
		%b++;
	}
	%invheight = %b*66 - 2;
	tmbi_transition.setvisible(0);

	if(%invheight+16 > $tmbi::pref::height)
	{
		if($tmbi::pref::fadeinventory)
			tmbi_transition.setvisible(1);
		%height = $tmbi::pref::height;
	}
	else
		%height = %invheight + 16;
	tmbi_debug(%invpos SPC %invheight SPC %height);
	%invpos = %height/2 - 66*getword($tmbi::current, 0) - 40; //yay math
	tmbi_debug(%invpos SPC %invheight SPC %height);

	if(%invpos > 0)
		%invpos = 0;
	%invpos += 8*tmbi_transition.isvisible();
	tmbi_debug(%invpos SPC %invheight SPC %height);

	if(%invpos*-1 + %height - 16 > %invheight)
		%invpos = %height - %invheight - 16;
	tmbi_debug(%invpos SPC %invheight SPC %height);
	tmbi_UINAME.settext("<color:"@tmbi_coltohex($tmbi::pref::color1)@"><font:"@ $tmbi::pref::font @":16><just:center>"@ $tmbi::brick[getword($tmbi::current,0), getword($tmbi::current,1)].uiname);
	tmbi_inv_list.resize(0, %invpos, 640, %invheight);
	tmbi_usebrick(getword($tmbi::current,0), getword($tmbi::current,1));
}

function tmbi_gotbricks()
{
	for(%a=0; %a<$tmbi::rowcount; %a++)
	{
		if(!$tmbi::hiddenrow[%a])
		{
			for(%b=0; %b<10; %b++)
			{
				if($tmbi::brick[%a, %b] !$= "")
					return true;
			}
		}
	}
	return false;
}

//when you hold down a button in the inventory
function tmbi_verticalspamloop(%x)
{
	if(iseventpending($tmbi::verticalspamloop))
		cancel($tmbi::verticalspamloop);

	if(!tmbi_isscrollactive())
		return;
	if(%x)
		tmbi_up();
	else
		tmbi_down();
	$tmbi::verticalspamloop = schedule(250, 0, tmbi_verticalspamloop, %x);
}

function tmbi_horizontalspamloop(%x)
{
	if(iseventpending($tmbi::horizontalspamloop))
		cancel($tmbi::horizontalspamloop);

	if(!tmbi_isscrollactive())
		return;
	if(%x)
		tmbi_right();
	else
		tmbi_left();
	$tmbi::horizontalspamloop = schedule(50, 0, tmbi_horizontalspamloop, %x);
}

if(ispackage(tmbi))
	deactivatepackage(tmbi);

package tmbi
{
	function invup(%x)
	{
		while(iseventpending($tmbi::verticalspamloop))
			cancel($tmbi::verticalspamloop);

		if(tmbi_isScrollActive())
		{
			if(%x)
			{
				$tmbi::verticalspamloop = schedule(500, 0, tmbi_verticalspamloop, 1);
				tmbi_up();
			}
		}
		else
			parent::invup(%x);
	}

	function invdown(%x)
	{
		while(iseventpending($tmbi::verticalspamloop))
			cancel($tmbi::verticalspamloop);

		if(tmbi_isScrollActive())
		{
			if(%x)
			{
				$tmbi::verticalspamloop = schedule(500, 0, tmbi_verticalspamloop, 0);
				tmbi_down();
			}
		}
		else
			parent::invdown(%x);
	}

	function invleft(%x)
	{
		while(iseventpending($tmbi::horizontalspamloop))
			cancel($tmbi::horizontalspamloop);

		if(tmbi_isScrollActive())
		{
			if(%x)
			{
				$tmbi::horizontalspamloop = schedule(500, 0, tmbi_horizontalspamloop, 0);
				tmbi_left();
			}
		}
		else
			parent::invleft(%x);
	}

	function invright(%x)
	{
		while(iseventpending($tmbi::horizontalspamloop))
			cancel($tmbi::horizontalspamloop);

		if(tmbi_isScrollActive())
		{
			if(%x)
			{
				$tmbi::horizontalspamloop = schedule(500, 0, tmbi_horizontalspamloop, 1);
				tmbi_right();
			}
		}
		else
			parent::invright(%x);
	}

	function BSD_ShowTab(%x)
	{
		if($tmbi::selshopbrick !$= "")
			$BSD_activeBitmap[$tmbi::selshopbrick].setvisible(0);
		$tmbi::selshopbrick = "";
		parent::BSD_ShowTab(%x);
	}

	//I may have overwritten too much in terms of how scrolling works.
	function setscrollmode(%x)
	{
		if(%x != $SCROLLMODE_BRICKS)
		{
			if($tmbi::open)
				tmbi_toggle();
		}
		return parent::setscrollmode(%x);
	}

	function scrollinventory(%x)
	{
		if(tmbi_isScrollActive())
		{
			if(!$tmbi::open)
				tmbi_toggle();
			else
			{
				if($tmbi_control) //sexines ejaculated by conan
				{
					if(%x < 0)
						tmbi_down();
					else
						tmbi_up();
				}
				else
				{
					if($pref::input::reversebrickscroll) //thank ye muzzles
						%x*=-1;
					if(%x < 0)
						tmbi_right();
					else
						tmbi_left();
				}
			}
		}
		else
			parent::scrollinventory(%x);
	}

	function mousefire(%x)
	{
		parent::mousefire(%x);
		$tmbi_mousefire = %x;

		if(!%x)
		{
			if($tmbi::pref::mousemover)
				tmbi_toggleghostmover(0);
		}
		else
		{
			if(isobject(serverconnection.getcontrolobject()))
			{
				if(isobject(serverconnection.getcontrolobject().getmountedimage(0)))
				{
					if(serverconnection.getcontrolobject().getmountedimage(0).shapefile $= "base/data/shapes/brickWeapon.dts")
					{
						if(!isobject($tmbi_ghostbrick))
						{
							while(iseventpending($tmbi_looktick))
								cancel($tmbi_looktick);
							$tmbi_lookstart = getsimtime();
							$tmbi_lookpos = vectoradd(tmbi_getfocuspos(), "0 0 "@$tmbi::brick[getword($tmbi::current, 0), getword($tmbi::current, 1)].bricksizez/2);
							$tmbi_lookbestdist = "";
							$tmbi_lookbestobj = "";
							$tmbi_ghostpos = "";
							tmbi_looktick();
						}
						else
						{
							if($tmbi::pref::mousemover)
								tmbi_toggleghostmover(1);
						}
					}
				}
			}
		}
	}

	//I killed your parents
	function handlesetinvdata(%WhoCares, %iSureDont, %slot, %dtb)
	{
		$tmbi::brick[getword($tmbi::current, 0), %slot] = %dtb;
		tmbi_update();
	}

	function BSD_ClickFav(%x)
	{
		tmbi_clickfav(%x);
	}

	function BSD_ClickIcon(%x)
	{
		tmbi_selectbrick(%x);
	}

	function BSD_ClickInv(%x) //removed
	{
		//click on slot for brick
		return;
	}

	function BSD_RightClickIcon(%x)
	{
		if(BrickSelectorDlg.isawake()) //else is witchcraft
		{
			$tmbi_instantusing = 1;
			canvas.popdialog(BrickSelectorDlg);
			$tmbi_instantusing = 0;
		}
		commandtoserver('instantusebrick', %x);
	}

	function BSD_ClickClear() //replaced
	{
		tmbi_clearcart();
	}

	function BSD_BuyBricks() //replaced
	{
		for(%a=0; %a<10; %a++)
			commandtoserver('buybrick', %a, $BSD_InvData[%a]);
	}

	function openbsd(%x)
	{
		if(%x)
			tmbi_openbsd();
	}

	function usebricks(%x)
	{
		if(%x)
			tmbi_toggle();
	}

	function usefirstslot(%x)
	{
		if(!%x)
			return;

		if(!$tmbi::open || (getword($tmbi::current, 1) $= "0" && !$tmbi_macroloadbypass))
			tmbi_toggle();

		if($tmbi::open && $tmbi::brick[getword($tmbi::current, 0), 0] !$= "")
			//$tmbi::current = getword($tmbi::current, 0) SPC "0";
			tmbi_setcurrent(getword($tmbi::current, 0) SPC "0");
		//tmbi_update();
	}

	function usesecondslot(%x)
	{
		if(!%x)
			return;

		if(!$tmbi::open || getword($tmbi::current, 1) $= "1")
			tmbi_toggle();

		if($tmbi::open && $tmbi::brick[getword($tmbi::current, 0), 1] !$= "")
			//$tmbi::current = getword($tmbi::current, 0) SPC "1";
			tmbi_setcurrent(getword($tmbi::current, 0) SPC "1");
		//tmbi_update();
	}

	function usethirdslot(%x)
	{
		if(!%x)
			return;

		if(!$tmbi::open || getword($tmbi::current, 1) $= "2")
			tmbi_toggle();

		if($tmbi::open && $tmbi::brick[getword($tmbi::current, 0), 2] !$= "")
			//$tmbi::current = getword($tmbi::current, 0) SPC "2";
			tmbi_setcurrent(getword($tmbi::current, 0) SPC "2");
		//tmbi_update();
	}

	function usefourthslot(%x)
	{
		if(!%x)
			return;

		if(!$tmbi::open || getword($tmbi::current, 1) $= "3")
			tmbi_toggle();

		if($tmbi::open && $tmbi::brick[getword($tmbi::current, 0), 3] !$= "")
			//$tmbi::current = getword($tmbi::current, 0) SPC "3";
			tmbi_setcurrent(getword($tmbi::current, 0) SPC "3");
		//tmbi_update();
	}

	function usefifthslot(%x)
	{
		if(!%x)
			return;

		if(!$tmbi::open || getword($tmbi::current, 1) $= "4")
			tmbi_toggle();

		if($tmbi::open && $tmbi::brick[getword($tmbi::current, 0), 4] !$= "")
			//$tmbi::current = getword($tmbi::current, 0) SPC "4";
			tmbi_setcurrent(getword($tmbi::current, 0) SPC "4");
		//tmbi_update();
	}

	function usesixthslot(%x)
	{
		if(!%x)
			return;

		if(!$tmbi::open || getword($tmbi::current, 1) $= "5")
			tmbi_toggle();

		if($tmbi::open && $tmbi::brick[getword($tmbi::current, 0), 5] !$= "")
			//$tmbi::current = getword($tmbi::current, 0) SPC "5";
			tmbi_setcurrent(getword($tmbi::current, 0) SPC "5");
		//tmbi_update();
	}

	function useseventhslot(%x)
	{
		if(!%x)
			return;

		if(!$tmbi::open || getword($tmbi::current, 1) $= "6")
			tmbi_toggle();

		if($tmbi::open && $tmbi::brick[getword($tmbi::current, 0), 6] !$= "")
			//$tmbi::current = getword($tmbi::current, 0) SPC "6";
			tmbi_setcurrent(getword($tmbi::current, 0) SPC "6");
		//tmbi_update();
	}

	function useeighthslot(%x)
	{
		if(!%x)
			return;

		if(!$tmbi::open || getword($tmbi::current, 1) $= "7")
			tmbi_toggle();

		if($tmbi::open && $tmbi::brick[getword($tmbi::current, 0), 7] !$= "")
			//$tmbi::current = getword($tmbi::current, 0) SPC "7";
			tmbi_setcurrent(getword($tmbi::current, 0) SPC "7");
		//tmbi_update();
	}

	function useninthslot(%x)
	{
		if(!%x)
			return;

		if(!$tmbi::open || getword($tmbi::current, 1) $= "8")
			tmbi_toggle();

		if($tmbi::open && $tmbi::brick[getword($tmbi::current, 0), 8] !$= "")
			//$tmbi::current = getword($tmbi::current, 0) SPC "8";
			tmbi_setcurrent(getword($tmbi::current, 0) SPC "8");
		//tmbi_update();
	}

	function usetenthslot(%x)
	{
		if(!%x)
			return;

		if(!$tmbi::open || getword($tmbi::current, 1) $= "9")
			tmbi_toggle();

		if($tmbi::open && $tmbi::brick[getword($tmbi::current, 0), 9] !$= "")
			//$tmbi::current = getword($tmbi::current, 0) SPC "9";
			tmbi_setcurrent(getword($tmbi::current, 0) SPC "9");
		//tmbi_update();
	}

//MORE FUN STUFF
	function buildfullmapstring(%x) //if someone tries to overwrite it
	{
		%a = parent::buildfullmapstring(%x);
		tmbi_debug("buildfullmapstring: "@ %x SPC %a);

		if(getfield(%a, 1) $= "LCONTROL")
		{
			$tmbi::prevctrl = $remapcmd[%x]; //play nice

			if($tmbi::open) //how did they pull this off?
				movemap.bind(keyboard, lcontrol, tmbi_control); //denied
		}
		return %a;
	}

	function playgui::onrender(%gui)
	{
		parent::onrender(%gui);

		if(serverconnection.tmbi_setup) //make sure it isn't just a silly gui refresh
		{
			//these things are like little gremlins that keep coming back aaaargh
			HUD_BrickNameBG.setvisible(0); //because deleting is mean
			HUD_BrickBox.setvisible(0);
			return;
		}
		serverconnection.tmbi_setup = true;
		createuinametable(); //someone hates me
		tmbi_clickfav(1);
		tmbi_setinventorydata();
		tmbi_activateinventory();
	}

	//so it overwrites package function after downloading off rtb
	function playgui::onwake(%gui, %idk)
	{
		return parent::onwake(%gui, %idk);
	}

	function disconnectedCleanup()
	{
		if($tmbi::open)
			tmbi_toggle();
		$tmbi::rebindrejected = 0;
		$tmbi::repurposekeybinds = 0;
		parent::disconnectedCleanup();
	}

	function canvas::pushdialog(%canvas, %gui)
	{
		parent::pushdialog(%canvas, %gui);

		if(%gui.getname() !$= "NewChatHud")
			$tmbi::scrollblockers = tmbi_addtolist($tmbi::scrollblockers, %gui);
	}

	function canvas::popdialog(%canvas, %gui)
	{
		parent::popdialog(%canvas, %gui);
		$tmbi::scrollblockers = tmbi_removefromlist($tmbi::scrollblockers, %gui);

		if(tmbi_isscrollactive() && $tmbi::wasopen)
		{
			$tmbi::wasopen = false;
			tmbi_toggle();
		}
	}

	function OptionsDlg::onsleep(%gui, %idk)
	{
		parent::onsleep(%gui, %idk);
		tmbi_update(); //may have changed gui options, update takes care of that
	}

	function brickselectordlg::onwake(%this, %idk)
	{
		//nothing yet
		parent::onwake(%this, %idk);
		tmbi_firsttimeinit();

		if(getword(BSD_Window.getextent(), 1) > getword(playgui.getextent(), 1))
		{
			tmbi_debug("oh dear, your pitifully small screen can't handle the awesome.");
			BSD_Window.resize(getword(BSD_Window.getposition(),0), 0, 640, getword(playgui.getextent(), 1));
		}

		if($tmbi_closepos !$= "")
		{
			tmbi_Debug("Last close position at: "@ $tmbi_closepos);
			BSD_Window.resize(getword($tmbi_closepos, 0), getword($tmbi_closepos, 1), 640, getword(BSD_Window.getextent(), 1));
		}

		if(getword(BSD_Window.getposition(), 1) < 0)
		{
			tmbi_debug("repositioning ...");
			BSD_Window.resize(getword(BSD_Window.getposition(),0), 0, 640, getword(BSD_Window.getextent(), 1));
		}
		TMBI_MainInventory.setvisible(0);
		BSD_Window.pushtoback(tmbi_resizer); //this keeps moving around for some reason
		commandtoserver('bsd');
	}

	function brickselectordlg::onsleep(%this, %idk)
	{		
		if(BSD_FavsHelper.visible) //I am surprised that I bother to put stuff like this in
			BSD_SetFavs();
		$tmbi_closepos = BSD_Window.getposition();
		parent::onsleep(%this, %idk);
		TMBI_MainInventory.setvisible(1);

		HUD_BrickNameBG.setvisible(0); //because deleting is mean
		HUD_BrickBox.setvisible(0);

		tmbi_update();
	}

	function TMBI_GUI_1::onwake(%gui, %idk)
	{
		tmbi_options_cancel();
		parent::onwake(%gui, %idk);
	}

	function clientcmdsetbuildingdisabled(%x)
	{
		parent::clientcmdsetbuildingdisabled(%x);

		if(%x)
		{
			if($ScrollMode == $SCROLLMODE_BRICKS)
				setscrollmode($SCROLLMODE_TOOLS);
			if($tmbi::open)
				tmbi_toggle();

		}
	}

	function cancelbrick(%x)
	{
		parent::cancelbrick(%x);

		if(%x && isobject($tmbi_ghostbrick))
			$tmbi_ghostbrick = ""; //failsafe for if it finds the wrong ghostbrick
	}

	function ToggleBuildMacroRecording(%x)
	{
		parent::ToggleBuildMacroRecording(%x);

		if(%x && $recordingbuildmacro)
		{
			$BuildMacroSO.event[$BuildMacroSO.numEvents] = "Server\tInstantUseBrick\t"@ $tmbi::brick[getword($tmbi::current,0), getword($tmbi::current,1)]; //yay compatibility
			$BuildMacroSO.numEvents++;
		}
	}

	function LoadMacroFromFile()
	{
		if(isobject($buildmacroso))
			%id = $buildmacroso.getid();
		$tmbi_macroloadbypass = 1;
		parent::loadmacrofromfile();
		$tmbi_macroloadbypass = 0;

		if(!isobject($buildmacroso))
			return;

		if($buildmacroso.getid() == %id)
			return;

		for(%a=0; %a<$buildmacroso.numevents; %a++)
		{
			if(getfield($buildmacroso.event[%a], 1) $= "instantusebrick")
			{
				%field = getfield($buildmacroso.event[%a], 2);

				if(isobject($uinametable[%field]))
				{
					$buildmacroso.event[%a] = tmbi_setfield($buildmacroso.event[%a], 2, $uinametable[%field]);
					continue;
				}
				else if(isobject(%field)) //maybe they did it without tmbi or something I guess
					continue;
				else
				{
					for(%b=%a; %b<$buildmacroso.numevents; %b++)
						$buildmacroso.event[%b] = $buildmacroso.event[%b+1];
					$buildmacroso.numevents--;
				}
			}

			if(getfield($buildmacroso.event[%a], 1) $= "UseInventory" && !$tmbi::repurposekeybinds && !%q)
			{
				messageboxok("Attention!", "The macro that you have loaded may not be fully functional in your current build mode.\n\nPlease go to TMBI options in the brick selector and enable Vanilla Building Mode for best results.");
				%q = 1;
			}
		}
	}

	function SaveMacroToFile(%conf) //meh, couldn't think of a better way
	{
		for(%a=0; %a<$buildmacroso.numevents; %a++)
		{
			if(getfield($buildmacroso.event[%a], 1) $= "instantusebrick")
			{
				%temparray[%a] = getfield($buildmacroso.event[%a], 2);
				$buildmacroso.event[%a] = tmbi_setfield($buildmacroso.event[%a], 2, %temparray[%a].uiname);
			}
		}
		parent::savemacrotofile(%conf);

		for(%a=0; %a<$buildmacroso.numevents; %a++)
		{
			if(getfield($buildmacroso.event[%a], 1) $= "instantusebrick")
				$buildmacroso.event[%a] = tmbi_setfield($buildmacroso.event[%a], 2, %temparray[%a]);
		}
	}
};
activatepackage(tmbi);

//activation code
//should be called onceish

function tmbi_activateinventory()
{
	if(isobject(TMBI_MainInventory))
	{
		tmbi_update();
		return;
	}

	for(%a=$remapcount-1; %a>-1; %a--) //best bet that it is near end
	{
		if(getfield(OptRemapList.getrowtextbyid(%a), 1) $= "LCONTROL")
		{
			$tmbi::prevctrl = $remapcmd[%a];
			break;
		}
	}
	HUD_BrickNameBG.setvisible(0); //because deleting is mean
	HUD_BrickBox.setvisible(0);

	new GuiSwatchCtrl(TMBI_MainInventory)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "center";
		vertSizing = "top";
		position = "0 0"; //do it later
		extent = "640" SPC $tmbi::pref::height;
		minExtent = "8 2";
		visible = "1";
		color = "0 0 0 0";

		new GuiSwatchCtrl(tmbi_scroll_area)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "center";
			vertSizing = "height";
			position = "0 16";
			extent = "640" SPC $tmbi::pref::height-16;
			minExtent = "8 2";
			visible = "1";
			color = "100 100 100 0";

			new GuiSwatchCtrl(tmbi_inv_list)
			{
				profile = "GuiDefaultProfile";
				horizSizing = "center";
				vertSizing = "bottom";
				position = "0 0";
				extent = "640 0"; //will expand to accomodate more rows
				minExtent = "8 2";
				visible = "1";
				color = "0 0 0 0";

				//Rows insert into here with 66px spacing
			};
		};
		new GuiBitmapCtrl(tmbi_transition)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 16";
			extent = "640 24";
			minExtent = "8 2";
			visible = $tmbi::pref::fadeinventory;
			bitmap = "./ui/transition.png";
			wrap = "0";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";
		};
		new GuiBitmapCtrl(tmbi_barthing)
		{
			profile = "GuiDefaultProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "0 0";
			extent = "640 16";
			minExtent = "8 2";
			visible = "1";
			bitmap = "./ui/top.png";
			wrap = "0";
			lockAspectRatio = "0";
			alignLeft = "0";
			overflowImage = "0";
			keepCached = "0";

			new GuiMLTextCtrl(tmbi_UINAME)
			{
				profile = "GuiMLTextProfile";
				horizSizing = "center";
				vertSizing = "top";
				position = "0 0";
				extent = "640 16";
				minExtent = "8 2";
				visible = "1";
				lineSpacing = "2";
				allowColorChars = "0";
				maxChars = "-1";
				text = "<color:"@tmbi_coltohex($tmbi::pref::color1)@"><font:"@ $tmbi::pref::font @":16><just:center>Too Many Bricks Inventory";
				maxBitmapHeight = "-1";
				selectable = "1";
			};
		};
	};
	playgui.add(TMBI_MainInventory);
	tmbi_update();
}

//more activation code, used in a different context however

function tmbi_firsttimeinit()
{
	BSD_DoneButton.setvisible(0);
	BSD_ClearBtn.setvisible(0);
	BSD_InvBox.setvisible(0);
	BSD_Window.settext("TMBI Brick Selector");
	BSD_FavsHelper.delete(); //this one is full of fiddlesticks
	%gui = new GuiSwatchCtrl(BSD_FavsHelper) //fiddlesticks I tell you!
	{
		profile = "BlockWindowProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "192 25";
		extent = "269 27";
		minExtent = "8 2";
		visible = "0";
		color = "78 83 235 240";

		new GuiTextCtrl()
		{
			profile = "BlockWindowProfile";
			horizSizing = "center";
			vertSizing = "bottom";
			position = "22 3";
			extent = "225 18";
			minExtent = "8 2";
			visible = "1";
			text = "^^^ Click a number to set favorites ^^^";
			maxLength = "255";
		};
	};
	BSD_Window.add(%gui);

	for(%a=0; %a<BSD_ScrollBox.getcount(); %a++)
	{
		%gui = BSD_ScrollBox.getobject(%a);
		%gui.vertsizing = "height";
	}

	if(isobject(tmbi_sellist)) //sometimes the above guys magically come back
		return;
	BSD_Window.accelerator = "enter";
	BSD_Window.command = "tmbi_clickdone();";
	BSD_Window.resizeheight = 1;
	BSD_Window.minsize = "640 480";
	BSD_Window.resize(getword(BSD_Window.getposition(), 0), getword(BSD_Window.getposition(),1) - 60, 640, 600);
	BSD_ScrollBox.vertsizing = "height";

	%gui = new GuiScrollCtrl(TMBI_ScrollBox)
	{
		profile = "GuiScrollProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "3 419";
		extent = "634 156";
		minExtent = "8 2";
		visible = "1";
		willFirstRespond = "0";
		hScrollBar = "alwaysOff";
		vScrollBar = "alwaysOn";
		constantThumbHeight = "0";
		childMargin = "0 0";
		rowHeight = "40";
		columnWidth = "30";

		new GuiSwatchCtrl(tmbi_sellist) 
		{
			profile = "GuiDefaultProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "1 1";
			extent = "617 0";
			minExtent = "8 2";
			visible = "1";
			color = "0 0 0 0";
		};
	};
	BSD_Window.add(%gui);
	%gui = new GuiBitmapButtonCtrl(tmbi_btn7)
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "512 566";
		extent = "100 30";
		minExtent = "8 2";
		visible = "1";
		command = "tmbi_clickdone();";
		accelerator = "";
		text = "DONE";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
	};
	BSD_Window.add(%gui);
	%gui = new GuiBitmapButtonCtrl(tmbi_btn6)
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "444 576";
		extent = "60 20";
		minExtent = "8 2";
		visible = "1";
		command = "tmbi_options();";
		accelerator = "";
		text = "Options";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
	};
	BSD_Window.add(%gui);
	%gui = new GuiBitmapButtonCtrl(tmbi_btn5)
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "376 576";
		extent = "60 20";
		minExtent = "8 2";
		visible = "1";
		command = "tmbi_clickcancel();";
		accelerator = "escape";
		text = "Cancel";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
	};
	BSD_Window.add(%gui);
	%gui = new GuiBitmapButtonCtrl(tmbi_btn4)
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "308 576";
		extent = "60 20";
		minExtent = "8 2";
		visible = "1";
		command = "tmbi_reset();";
		accelerator = "";
		text = "Reset";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
	};
	BSD_Window.add(%gui);
	%gui = new GuiBitmapButtonCtrl(tmbi_btn3)
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "240 576";
		extent = "60 20";
		minExtent = "8 2";
		visible = "1";
		command = "tmbi_clearcart();";
		accelerator = "";
		text = "Empty";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
	};
	BSD_Window.add(%gui);
	%gui = new GuiBitmapButtonCtrl(tmbi_btn2)
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "172 576";
		extent = "60 20";
		minExtent = "8 2";
		visible = "1";
		command = "tmbi_help(0);";
		accelerator = "";
		text = "Help";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
	};
	BSD_Window.add(%gui);
	%gui = new GuiBitmapButtonCtrl(tmbi_btn1)
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "104 576";
		extent = "60 20";
		minExtent = "8 2";
		visible = "1";
		command = "tmbi_addrow();";
		accelerator = "";
		text = "Add Row";
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "base/client/ui/button1";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
	};
	BSD_Window.add(%gui);
	%gui = new GuiSwatchCtrl()
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = "4 576";
		extent = "100 20";
		minExtent = "8 2";
		visible = "1";
		color = "0 0 0 0";

		new GuiTextCtrl(TMBI_TEXTDISPLAY)
		{
			profile = "GuiTextProfile";
			horizSizing = "right";
			vertSizing = "bottom";
			position = "3 1";
			extent = "63 18";
			minExtent = "8 2";
			visible = "1";
			text = "Brick UIName";
			maxLength = "255";
		};
	};
	BSD_Window.add(%gui);
	%gui = new GuiBitmapButtonCtrl()
	{
		profile = "BlockButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "500 4";
		extent = "96 18";
		minExtent = "8 2";
		visible = "1";
		command = "tmbi_versioncheck(1);";
		text = $tmbi::version;
		groupNum = "-1";
		buttonType = "PushButton";
		bitmap = "./ui/btn1";
		lockAspectRatio = "0";
		alignLeft = "0";
		overflowImage = "0";
		mKeepCached = "0";
		mColor = "255 255 255 255";
	};
	BSD_Window.add(%gui);
	$tmbi::resizerpos = "3 418"; //updates and junk, idk

	%gui = new GuiMouseEventCtrl(TMBI_Resizer)
	{
		profile = "GuiDefaultProfile";
		horizSizing = "right";
		vertSizing = "top";
		position = $tmbi::resizerpos;
		extent = "618 6";
		minExtent = "8 2";
		visible = "1";
		lockMouse = "0";
	};
	BSD_Window.add(%gui);

	tmbi_clearcart();
	tmbi_clickfav(1);

	if($tmbi::pref::autocheck)
		tmbi_versioncheck();
}

function tmbi_options()
{
	canvas.pushdialog(TMBI_GUI1);
}

function tmbi_isScrollActive()
{
	if($ScrollMode != $SCROLLMODE_BRICKS && $ScrollMode != $SCROLLMODE_NONE || $BuildingDisabled || $ZoomOn)
		return 0;

	for(%a=0; %a<getwordcount($tmbi::scrollblockers); %a++)
	{
		%gui = getword($tmbi::scrollblockers, %a);

		if(isobject(%gui))
		{
			if(%gui.isawake())
				return 0;
		}
		$tmbi::scrollblockers = tmbi_removefromlist($tmbi::scrollblockers, %gui);
	}
	return 1;
}

//support for ghost brick manipulator
function tmbi_looktick()
{
	tmbi_debug("ticking to find");

	if(iseventpending($tmbi_looktick))
		cancel($tmbi_looktick);

	if($tmbi_lookstart $= "")
		$tmbi_lookstart = getsimtime();

	if($tmbi_lookpos $= "")
		$tmbi_lookpos = vectoradd(tmbi_getfocuspos(), "0 0 "@$tmbi::brick[getword($tmbi::current, 0), getword($tmbi::current, 1)].bricksizez/2);

	if($tmbi_lastlookobj $= "")
		$tmbi_lastlookobj = serverconnection.getobject(serverconnection.getcount()-1);

	for(%a=serverconnection.getcount()-1; %a>-1; %a--)
	{
		//watches serverconnection for anything that looks like your ghostbrick
		%obj = serverconnection.getobject(%a);

		if(%obj.getid() <= $tmbi_lastlookobj)
			break;

		if(%obj.getclassname() $= "fxdtsbrick")
		{
			if(!%obj.isplanted() && %obj.getdatablock().getid() == $tmbi::brick[getword($tmbi::current,0), getword($tmbi::current,1)])
			{
				%dist = vectordist($tmbi_lookpos, %obj.getposition());

				if(%dist < $tmbi_lookbestdist || $tmbi_lookbestdist $= "")
				{
					$tmbi_lookbestdist = %dist;
					$tmbi_lookbestobj = %obj;
				}
			}
		}
	}
	$tmbi_lastlookobj = serverconnection.getobject(serverconnection.getcount()-1);

	if(getsimtime() - $tmbi_lookstart > 500 || ($tmbi_lookbestdist !$= "" && $tmbi_lookbestdist < 5))
	{
		tmbi_lookend();
		return;
	}
	$tmbi_looktick = schedule(1, 0, tmbi_looktick);
}

function tmbi_lookend()
{
	while(iseventpending($tmbi_looktick)) //I hate while statements
		cancel($tmbi_looktick);

	if($tmbi_lookbestobj $= "")
	{
		tmbi_debug("found nothing...");
		return;
	}
	$tmbi_ghostbrick = $tmbi_lookbestobj;

	if($tmbi_mousefire && $tmbi::pref::mousemover)
		tmbi_toggleghostmover(1);
}

function tmbi_toggleGhostMover(%x)
{
	while(iseventpending($tmbi_ghostmovetick))
		cancel($tmbi_ghostmovetick);

	if(!%x)
	{
		//dunno
	}
	else
	{
		tmbi_ghostmovetick(1);
	}
}

function tmbi_ghostmovetick(%x)
{
	while(iseventpending($tmbi_ghostmovetick))
		cancel($tmbi_ghostmovetick);

	if(!isobject($tmbi_ghostbrick))
	{
		clientcmdcenterprint("\c2You need to clear and place a new ghost brick for this to work.", 3);
		return;
	}

	if(%x)
		$tmbi_ghostpos = $tmbi_ghostbrick.getposition();
	if(getword(serverconnection.getcontrolobject().getmuzzlevector(0), 2) < 0 || HUD_SuperShift.isvisible())
		%lookin = vectoradd(tmbi_getfocuspos(), "0 0 "@$tmbi_ghostbrick.getdatablock().bricksizez/10);
	else
		%lookin = vectorsub(tmbi_getfocuspos(), "0 0 "@$tmbi_ghostbrick.getdatablock().bricksizez/10);

	if($tmbi_ghostpos $= "")
		$tmbi_ghostpos = %lookin;
	%test = tmbi_shiftfromto($tmbi_ghostpos, %lookin, $tmbi_ghostbrick.getdatablock(), $tmbi_ghostbrick.getangleid());
	$tmbi_ghostpos = %lookin;

	if(%test)
	{
		while(iseventpending($tmbi_ghostmovesync))
			cancel($tmbi_ghostmovesync);
		$tmbi_ghostmovesync = schedule(serverconnection.getping()+100, 0, tmbi_ghostmovesync);
	}
	$tmbi_ghostmovetick = schedule(1, 0, tmbi_ghostmovetick);
}

//gets out of sync when you turn your blockhead.  Hard to compensate
function tmbi_ghostmovesync()
{
	while(iseventpending($tmbi_ghostmovesync))
		cancel($tmbi_ghostmovesync);
	if(isobject($tmbi_ghostbrick))
		$tmbi_ghostpos = $tmbi_ghostbrick.getposition();
}

//pulled from buildbot mostly
function tmbi_shiftfromto(%posa, %posb, %dtb, %dir)
{
	%posa = tmbi_snaptobrickgrid(%posa, %dtb, %dir);
	%posb = tmbi_snaptobrickgrid(%posb, %dtb, %dir);

	if(%posa $= %posb)
		return 0;

	%shiftx = getword(%posb, 0) - getword(%posa, 0);
	%shifty = getword(%posb, 1) - getword(%posa, 1);
	%shiftz = getword(%posb, 2) - getword(%posa, 2);

	if(%dir2 = tmbi_getplayerdirection())
	{
		if(%dir2 == 1)
		{
			%a = %shifty;
			%shifty = %shiftx * -1;
			%shiftx = %a;
		}
		else if(%dir2 == 2)
		{
			%shiftx = %shiftx * -1;
			%shifty = %shifty * -1;
		}
		else if(%dir2 == 3)
		{
			%a = %shiftx;
			%shiftx = %shifty * -1;
			%shifty = %a;
		}
	}
	tmbi_debug("shifting: "@%shiftx SPC %shifty SPC %shiftz);

	if($tmbi::pref::altshift)
	{
		commandtoserver('shiftbrick', %shiftx, 0, 0);
		commandtoserver('shiftbrick', 0, %shifty, 0);
		commandtoserver('shiftbrick', 0, 0, %shiftz);
	}
	else
		commandtoserver('shiftbrick', %shiftx, %shifty, %shiftz);
	return 1;
}

//this function is actually more accurate than the default system, interestingly enough
function tmbi_snaptobrickgrid(%pos, %dtb, %dir) //beautiful
{
	%sx = %dtb.bricksizex;
	%sy = %dtb.bricksizey;
	%sz = %dtb.bricksizez;

	if(%sx $= "" || %sy $= "" || %sz $= "")
	{
		tmbi_debug("Bad Datablock sent: "@ %dtb);
		return;
	}
	%x = getword(%pos, 0)*2;
	%y = getword(%pos, 1)*2;
	%z = mceil(getword(%pos, 2)*5); //sometimes bricks are at 0.1997 instead of 0.2 because badspot gave them cancer

	if(HUD_SuperShift.isvisible()) //super shift is enabled, use a whimsical adjusted brickgrid instead of normal one.
	{
		%org = $tmbi_ghostbrick.getposition();

		if(%org !$= "") //if we have a ghost brick
		{
			//convert original position to brick grid
			%ox = getword(%org, 0)*2;
			%oy = getword(%org, 1)*2;
			%oz = mceil(getword(%org, 2)*5);

			if($tmbi_ghostbrick.getangleid() % 2) //if it is facing north or south
			{
				%y = tmbi_mround((%y - %oy)/%sx)*%sx;
				%x = tmbi_mround((%x - %ox)/%sy)*%sy;
			}
			else //east or west
			{
				//can also be done with modulus, but screw that
				%x = tmbi_mround((%x - %ox)/%sx)*%sx;
				%y = tmbi_mround((%y - %oy)/%sy)*%sy;
			}
			%z = mfloor((%z - %oz)/%sz)*%sz; //ack
		}
	}
	else
	{
		if(!tmbi_isint(%dir/2)) //asdf this entire everything
		{
			if(!tmbi_isint(%sx/2))
				%y = mfloor(%y);
			else
				%y = tmbi_mround(%y);

			if(!tmbi_isint(%sy/2)) //modulus is for squares
				%x = mfloor(%x);
			else
				%x = tmbi_mround(%x);
		}
		else
		{
			if(!tmbi_isint(%sx/2))
				%x = mfloor(%x);
			else
				%x = tmbi_mround(%x);

			if(!tmbi_isint(%sy/2))
				%y = mfloor(%y);
			else
				%y = tmbi_mround(%y);
		}
	}
	return %x SPC %y SPC %z;
}

function tmbi_mround(%x)
{
	return mfloor(%x + 0.5);
}

//0 - East
//1 - South
//2 - West
//3 - North
function tmbi_getplayerdirection()
{
	if(isObject(%p = serverconnection.getcontrolobject()))
	{
		if(%p.getdatablock().classname $= "CameraData" && $tmbi_lastplayerdir !$= "")
			return $tmbi_lastplayerdir;
		else
		{
			%va = getword(%p.getforwardvector(),0);
			%vb = getword(%p.getforwardvector(),1);

			if(mabs(%va) > mabs(%vb))
			{
				if(%va > 0)
					$tmbi_lastplayerdir = 0;
				else
					$tmbi_lastplayerdir = 2;
			}
			else
			{
				if(%vb > 0)
					$tmbi_lastplayerdir = 1;
				else
					$tmbi_lastplayerdir = 3;
			}
			return $tmbi_lastplayerdir;
		}
	}
	else
		return 4;
}

//fun trick:
//overwrite this function in console with the following command to obtain a pet brick when using the ghost brick mover
//function tmbi_getfocuspos(){return vectorsub(serverconnection.getcontrolobject().getposition(), serverconnection.getcontrolobject().getforwardvector());}

function tmbi_getfocuspos()
{
	%dist = getfocusdistance();
	%eye = tmbi_getmyeyepoint();
	%vec = serverconnection.getcontrolobject().getmuzzlevector(0);
	%vec = vectorscale(%vec, %dist);
	return vectoradd(%eye, %vec);
}

//kinda wonky function, but still accurate for the default blockhead in reasonable ranges.
function tmbi_getmyeyepoint()
{
	%player = serverconnection.getcontrolobject();

	if(!isobject(%player))
		return "0 0 0";
	%pos = %player.getposition();
	%vec = %player.getforwardvector();
	%scale = %player.getscale();
	%x = getword(%pos, 0) + (getword(%vec, 0)*0.14 + 0.002)*getword(%scale, 0); //me no likey
	%y = getword(%pos, 1) + (getword(%vec, 1)*0.14 + 0.002)*getword(%scale, 1);
	%z = getword(%pos, 2) + (getword(%player.getdatablock().boundingbox, 2)/4.92 - $mvtriggercount3*1.53 + 0.002)*getword(%scale, 2); //optimized for standard blockhead, good luck otherwise
	return %x SPC %y SPC %z;
}

//resizer support
function TMBI_Resizer::OnMouseDown(%gui, %idk, %pos, %noidea)
{
	tmbi_activateresizer(%pos);
}

function TMBI_Resizer::OnMouseUp(%gui, %idk, %pos, %noidea)
{
	tmbi_deactivateresizer();
}

function TMBI_Resizer::OnMouseDragged(%gui, %idk, %pos, %noidea)
{
	if(!$tmbi_dragenabled)
		return;
	%y = getword(%pos, 1);
	%change = %y - $tmbi_lastresizepos;
	%currheight = getword(TMBI_ScrollBox.getextent(), 1);

	if(%currheight - %change > 315)
		%change = %currheight - 315;
	else if(%currheight - %change < 64)
		%change = %currheight - 64;

	if(%change == 0)
		return;

	$tmbi_lastresizepos = $tmbi_lastresizepos + %change;
	TMBI_ScrollBox.resize(3, getword(TMBI_ScrollBox.getposition(), 1) + %change, 634, getword(TMBI_ScrollBox.getextent(), 1) - %change);
	BSD_ScrollBox.resize(getword(BSD_ScrollBox.getposition(), 0), getword(BSD_ScrollBox.getposition(), 1), getword(BSD_ScrollBox.getextent(), 0), getword(BSD_ScrollBox.getextent(), 1) + %change);
}

function TMBI_Resizer::OnMouseLeave(%gui, %idk, %pos, %noidea)
{
	tmbi_deactivateresizer();
}

function tmbi_activateresizer(%pos)
{
	if($tmbi_dragenabled)
		return;
	tmbi_debug("activating resizer");
	TMBI_Resizer.resize(0, 0, 640, getword(BSD_Window.getextent(), 1));
	$tmbi_dragenabled = 1;
	$tmbi_lastresizepos = getword(%pos, 1);
}

function tmbi_Deactivateresizer()
{
	if(!$tmbi_dragenabled)
		return;
	tmbi_debug("deactivating resizer");
	TMBI_Resizer.resize(3, getword(TMBI_ScrollBox.getposition(), 1), 600, 6);
	$tmbi_dragenabled = 0;
}

//color manager
//if you want to understand this in more detail you should probably just pm me
function tmbi_colorwheelmctrl::onmousedragged(%this, %a, %pos, %b)
{
	tmbi_managerecolor(%pos);
}

function tmbi_colorwheelmctrl::onmousedown(%this, %a, %pos, %b)
{
	tmbi_managerecolor(%pos);
}

function getscreenpos(%gui)
{
	if(!isobject(%gui))
		return;
	%pos = %gui.getposition();
	%x = getword(%gui.getposition(), 0);
	%y = getword(%gui.getposition(), 1);

	while(isObject(%gui.getgroup()))
	{
		%gui = %gui.getgroup();

		if(%gui.getname() $= "Canvas")
			break;
		%pos = %gui.getposition();
		%x += getword(%pos, 0);
		%y += getword(%pos, 1);
	}
	return %x SPC %y;
}

function tmbi_managerecolor(%pos)
{
	tmbi_debug("  === INIT === ");
	tmbi_debug("    NEW BLOP");
	tmbi_debug("mouse pos "@%pos);
	%gpos = getscreenpos(tmbi_colorwheelimage);
	%centerx = getword(%gpos, 0) + 64;
	%centery = getword(%gpos, 1) + 64;
	tmbi_debug("Centers: "@%centerx SPC %centery);
	%offsetx = %centerx - getword(%pos,0);
	%offsety = getword(%pos,1) - %centery;
	tmbi_debug("offsets: "@%offsetx SPC %offsety);
	tmbi_pickcolor(%offsetx/-64, %offsety/-64);
}

function tmbi_pickcolor(%x, %y)
{
	tmbi_debug("RGB POS: "@%x SPC %y);
	%pi = matan(0,-1);
	tmbi_debug("pi: "@%pi);
	%angle = matan(%y, %x); //range pi to negative pi
	%r = msqrt(mpow(%x,2) + mpow(%y,2));

	if(%r > 1)
		%r = 1;
	tmbi_debug("pol: "@%r SPC %angle@" rad");

	for(%i=0; %i<3; %i++)
	{
		tmbi_debug(" ---color---");
		%mangle = %angle - mfloor(%angle/(2*%pi)) * (2*%pi); //locks onto 0 to 2pi range
		tmbi_debug(%angle SPC %mangle);

		if(%mangle > %pi*(1.5))
			%mangle -= 2*%pi;
		else if(%mangle > %pi/2)
		{
			%mangle -= %pi;
			%mangle *= -1;
		}
		tmbi_debug("final adjusted angle: "@%mangle);
		%min = (%mangle + %pi/6)/(%pi/3);
		tmbi_debug("min: "@%min);

		if(%min > 1)
			%min = 1;
		else if(%min < 0)
			%min = 0;
		%col = 1 - ((1-%min)*%r);

		if(%color $= "")
			%color = %col;
		else
			%color = %color SPC %col;
		%angle += %pi*(2/3);
	}
	tmbi_debug("color: "@%color);
	tmbi_setselectorcolor(%color);
}

function tmbi_setselectorcolor(%color)
{
	if(%color !$= "")
		$tmbi::colorselector::color = %color;

	if($tmbi::colorselector::shade > 1 || $tmbi::colorselector::shade $= "")
		$tmbi::colorselector::shade = 1;
	else if($tmbi::colorselector::shade < 0)
		$tmbi::colorselector::shade = 0;
	%cr = getword($tmbi::colorselector::color, 0) * $tmbi::colorselector::shade;
	%cg = getword($tmbi::colorselector::color, 1) * $tmbi::colorselector::shade;
	%cb = getword($tmbi::colorselector::color, 2) * $tmbi::colorselector::shade;
	%fullcol = %cr SPC %cg SPC %cb;

	if($tmbi::colorselector::current != 2 || $tmbi::colorselector::alpha > 1 || $tmbi::colorselector::alpha $= "")
		$tmbi::colorselector::alpha = 1;
	else if($tmbi::colorselector::alpha <= 0)
		$tmbi::colorselector::alpha = 0;
	$tmbi::colorselector::fullcolor[$tmbi::colorselector::current] = %fullcol SPC $tmbi::colorselector::alpha;
	tmbi_colorpreview.setcolor($tmbi::colorselector::fullcolor[$tmbi::colorselector::current]);

	if($tmbi::colorselector::current == 2)
		%fullcol = $tmbi::colorselector::fullcolor[$tmbi::colorselector::current];
	tmbi_colortext.settext(%fullcol);
	$tmbi_coloroverride = 1;
	tmbi_colorslider.setvalue($tmbi::colorselector::shade);
	tmbi_alphacolorslider.setvalue($tmbi::colorselector::alpha);
	$tmbi_coloroverride = 0;
}

function tmbi_nudgeslider()
{
	if($tmbi_coloroverride)
		return;
	tmbi_setselectorcolor();
}

function tmbi_nextcolormode()
{
	$tmbi::colorselector::current++;

	if($tmbi::colorselector::current > 2)
		$tmbi::colorselector::current = 0;
	tmbi_setcolormode($tmbi::colorselector::current);
}

function tmbi_prevcolormode()
{
	$tmbi::colorselector::current--;

	if($tmbi::colorselector::current < 0)
		$tmbi::colorselector::current = 2;
	tmbi_setcolormode($tmbi::colorselector::current);
}

function tmbi_setcolormode(%x)
{
	$tmbi::colorselector::current = %x;

	if(%x == 2)
	{
		%text = "HUD";
		%a = 1;
	}
	else
	{
		%a = 0;

		if(%x == 1)
			%text = "Secondary";
		else if(%x == 0)
			%text = "Primary";
		else
			return;
	}
	tmbi_alphacolorslider.setvisible(%a);
	tmbi_colormodetext.settext("<just:center><font:impact:18>"@%text);
	tmbi_setcolorfromtext($tmbi::colorselector::fullcolor[%x]);
}

function tmbi_setcolorfromtext(%color)
{
	tmbi_debug("here we gooooo: "@ %color);

	for(%a=0; %a<3; %a++)
	{
		%col[%a] = getword(%color, %a);
		tmbi_debug("initial color" SPC %a SPC %col[%a]);

		if(%hcol $= "" || %col[%a] > %hcol)
			%hcol = %col[%a];
	}
	tmbi_debug("highest color: "@ %hcol);

	for(%a=0; %a<3; %a++)
	{
		if(%hcol != 0)
			%col[%a] *= 1/%hcol; //will also lock the highest color to 1
		tmbi_debug("adjusted color" SPC %a SPC %col[%a]);

		if(%col[%a] > 1) //in case of rounding error
			%col[%a] = 1;
		else if(%col[%a] < 0) //in case of user input blargtarded
			%col[%a] = 0;
	}

	if($tmbi::colorselector::current == 2)
		$tmbi::colorselector::alpha = getword(%color, 3);
	$tmbi::colorselector::shade = %hcol;
	tmbi_setselectorcolor(%col0 SPC %col1 SPC %col2);
	tmbi_debug("final color: "@ $tmbi::colorselector::color);
}

//version check system
//if you want to learn to do tcp networking on blockland this is probably a decent resource
function tmbi_versioncheck(%x)
{
	if(!%x && isfile("./rtbinfo.txt") && isfile("add-ons/system_returntoblockland/client.cs"))
		return;
	$tmbi_manualconnect = %x;

	if(isobject(TMBI_Downloader))
		TMBI_Downloader.delete();

	new tcpobject(TMBI_Downloader);
	$tmbi::downloadphase = 0;
	TMBI_Downloader.connect("forum.blockland.us:80");
}

function TMBI_Downloader::onConnected(%this)
{
	if($tmbi::downloadphase == 0)
	{
		//forum.blockland.us/index.php?topic=161834.720
		%req = "GET /index.php?topic=161834.720 HTTP/1.0\nHost: forum.blockland.us\n\n";
		%this.send(%req);
	}
	else
	{
		%req = "GET /index.php?action=dlattach;topic=161834.0;attach="@ $tmbi::versionfile SPC"HTTP/1.0\nHost: forum.blockland.us\n\n";
		%this.send(%req);
	}
}

function TMBI_Downloader::onConnectFailed(%this)
{
	if($tmbi_manualconnect)
		messageboxok("Attention!", "Unable to connect to the online version information.");
}

function TMBI_Downloader::onDisconnect(%this)
{
	if(!$tmbi_connected)
	{
		if($tmbi_manualconnect)
			messageboxok("Attention!", "Unable to connect to the online version information.");
	}
	else
		$tmbi_connected = "";
}

function TMBI_Downloader::onLine(%this, %line)
{
	tmbi_debug("TMBI TCP: "@ %line);

	if($tmbi::downloadphase == 0)
	{
		if(strpos(%line, "Versions.txt") > -1)
		{
			%subline = "http://forum.blockland.us/index.php?action=dlattach;topic=161834.0;attach=";
			$tmbi::versionfile = getsubstr(%line, strpos(%line, %subline)+strlen(%subline), strpos(%line, "\">")-(strpos(%line, %subline)+strlen(%subline)));

			if(tmbi_isint($tmbi::versionfile))
			{
				$tmbi_connected = 1;
				TMBI_Downloader.disconnect();
				$tmbi::downloadphase = 1;
				TMBI_Downloader.connect("forum.blockland.us:80");
			}
			else
				TMBI_Downloader.disconnect();
		}
	}
	else
	{
		if(getsubstr(%line, 0, 23) $= "NARG MOD VERSION TMBI: ")
		{
			$tmbi_connected = 1;
			$tmbi_availableversion = getsubstr(%line, 23, strlen(%line)-23);

			if($tmbi_availableversion $= $tmbi::version)
				tmbi_versionresult(1);
			else
				tmbi_versionresult(0);
			TMBI_Downloader.disconnect();
		}
	}
}

function tmbi_versionresult(%x)
{
	if(%x)
	{
		if($tmbi_manualconnect)
			messageboxok("Good News!", "Your Too Many Bricks Inventory mod is up to date.");
	}
	else
		messageboxok("Attention!", "There is a more current version of your Too Many Bricks Inventory mod.\n\nYour Version: "@$tmbi::version@"\n\nAvailable: "@$tmbi_availableversion);
}

function tmbi_isint(%x) //I don't trust the sometimes default one
{
	if(%x $= mfloor(%x)) //also makes it sure it is a string
		return 1;
	return 0;
}

function tmbi_defaultprefs()
{
	if(isfile("base/client/ui/cache/calibri_18.gft"))
		$tmbi::pref::font = "calibri";
	else
		$tmbi::pref::font = "Palatino Linotype";
	$tmbi::pref::autocheck = 1;
	$tmbi::pref::height = 160;
	$tmbi::pref::fadeinventory = 1;
	$tmbi::pref::transweight = "0.8";
	$tmbi::repurposekeybinds = 0;
	$tmbi::pref::nextscroll = 1;
	$tmbi::pref::maxrowcount = 5;
	$tmbi::pref::mousemover = 0;
	$tmbi::pref::color0 = "1 0.4 0 1";
	$tmbi::pref::color1 = "1 1 1 1";
	$tmbi::pref::color2 = "0 0 0 1";
}

//list control stuff and things
function tmbi_isonlist(%list, %item)
{
	for(%a=0; %a<getwordcount(%list); %a++)
	{
		if(%item $= getword(%list, %a))
			return 1;
	}
	return 0;
}

function tmbi_addtolist(%list, %item)
{
	if(%list $= "")
		%list = %item;
	else
		%list = %list SPC %item;
	return %list;
}

function tmbi_removefromlist(%list, %item)
{
	for(%a=0; %a<getwordcount(%list); %a++)
	{
		if(%item !$= getword(%list, %a))
			%newlist = tmbi_addtolist(%newlist, getword(%list, %a));
	}
	return %newlist;
}

function tmbi_setfield(%list, %index, %replace)
{
	for(%a=0; %a<getfieldcount(%list); %a++)
	{
		if(%a == %index)
			%text = %replace;
		else
			%text = getfield(%list, %a);

		if(%newlist $= "")
			%newlist = %text;
		else
			%newlist = %newlist TAB %text;
	}
	return %newlist;
}

function tmbi_coltohex(%col)
{
	for(%a=0; %a<3; %a++)
		%b[%a] = tmbi_dectohex(getword(%col, %a)*255);
	return %b0 @ %b1 @ %b2;
}

function tmbi_dectohex(%x)
{
	%a0 = mfloor(%x/16);
	%a1 = mfloor(%x - 16*%a0);

	for(%i=0; %i<2; %i++)
	{
		if(%a[%i] == 10)
			%a[%i] = "a";
		else if(%a[%i] == 11)
			%a[%i] = "b";
		else if(%a[%i] == 12)
			%a[%i] = "c";
		else if(%a[%i] == 13)
			%a[%i] = "d";
		else if(%a[%i] == 14)
			%a[%i] = "e";
		else if(%a[%i] == 15)
			%a[%i] = "f";
	}
	return %a0 @ %a1;
}

//aren't I a nice guy? nope... :c
function clientcmdrepurposekeybinds(%x)
{
	tmbi_Debug("server wants to repurpose keybinds");

	if($tmbi::rebindrejected)
		return;
	$tmbi::repurposekeybinds = %x;

	if($tmbi::repurposekeybinds)
		messageboxyesno("TMBI: Attention!", $tmbi::rebindmsg, "", "$tmbi::repurposekeybinds=0;$tmbi::rebindrejected=1;");
}

function tmbi_help(%x)
{
	if(%x == 1) //font
		TMBI_Options_ExText.settext("<just:center><font:"@ TMBI_Options_val1.getvalue() @":18>Example Text");
	else if(%x == 2) //height
		messageboxok("TMBI Info", "The maximum height is the limit on how many pixels tall the brick box can be on your HUD.");
	else if(%x == 3) //trans weight
		messageboxok("TMBI Info", "Some spraycan colors are transparent, but transparent brick icons are hard to see.  The lower this number, the less transparent brick icons can be.");
	else if(%x == 4) //transition
		messageboxok("TMBI Info", "When the inventory can't fit all the rows into the brickbox, this determines whether a fancy little fading transition appears or if it just cuts off.");
	else if(%x == 5) //repurpose
		messageboxok("TMBI Info", "On rare occasions, a server will use the inventory keybinds (0-9) to do something other than building.  TMBI overwrites these commands by default, so enabling this will turn it back on.\n\nBasically, it turns back into the same thing as the old brick inventory.");
	else if(%x == 6) //autochecker
		messageboxok("TMBI Info", "It is nice to have the latest stuff, and if you let it, TMBI will go online and check to see if a new version is available for you.  It will not download or install anything.");
	else if(%x == 7) //scroll
		messageboxok("TMBI Info", "Uxie likes to complain about how scrolling off the edge of a row jumps down to the next one, which is apparently confusing.  This pref toggles that, and makes it so scroll doesn't jump over empty slots and search for the nearest filled one.");
	else if(%x == 8) //rowcount
		messageboxok("TMBI Info", "Too many rows is hard to navigate and can cause the selector to lag when you move it around.\n\nIt is reccommended to keep this number reasonable, but I can't stop you from setting it to 9001 and adding every brick in the selector five times.");
	else if(%x == 9)
		messageboxok("TMBI Info", "This makes it so that mouse1 does the same thing as pressing the ghost mover keybind.");
	else if(%x == 10)
		messageboxok("TMBI Info", "Does the server have a bot detector that is hitting your ghost brick mover?  Check this box!  It may be a little slower, but it will still get the job done.");
	else //generic help
	{
		canvas.pushdialog(TMBI_GUI2);
		tmbi_helpbox.setvalue("Click a tab above for relevant information");
	}
}

function tmbi_options_apply()
{
	$tmbi::pref::font = TMBI_Options_val1.getvalue();
	$tmbi::pref::height = TMBI_Options_val2.getvalue();
	$tmbi::pref::transweight = TMBI_Options_val3.getvalue();
	$tmbi::pref::fadeinventory = TMBI_Options_val4.getvalue();
	$tmbi::repurposekeybinds = TMBI_Options_val5.getvalue();
	$tmbi::pref::autocheck = TMBI_Options_val6.getvalue();
	$tmbi::pref::nextscroll = TMBI_Options_val7.getvalue();
	$tmbi::pref::maxrowcount = TMBI_Options_val8.getvalue();
	$tmbi::pref::mousemover = TMBI_Options_val9.getvalue();
	$tmbi::pref::altshift = TMBI_Options_val10.getvalue();

	for(%a=0; %a<3; %a++)
		$tmbi::pref::color[%a] = $tmbi::colorselector::fullcolor[%a];
	canvas.popdialog(TMBI_GUI1);
	export("$tmbi::pref::*", "config/client/TMBI/prefs.cs");
	tmbi_updatesel();
}

function tmbi_options_cancel()
{
	TMBI_Options_val1.setvalue($tmbi::pref::font);
	tmbi_help(1);
	TMBI_Options_val2.setvalue($tmbi::pref::height);
	TMBI_Options_val3.setvalue($tmbi::pref::transweight);
	TMBI_Options_val4.setvalue($tmbi::pref::fadeinventory);
	TMBI_Options_val5.setvalue($tmbi::repurposekeybinds);
	TMBI_Options_val6.setvalue($tmbi::pref::autocheck);
	TMBI_Options_val7.setvalue($tmbi::pref::nextscroll);
	TMBI_Options_val8.setvalue($tmbi::pref::maxrowcount);
	TMBI_Options_val9.setvalue($tmbi::pref::mousemover);
	TMBI_Options_val10.setvalue($tmbi::pref::altshift);

	for(%a=0; %a<3; %a++)
		$tmbi::colorselector::fullcolor[%a] = $tmbi::pref::color[%a];
	tmbi_setcolormode(0);

	if(TMBI_GUI1.isawake())
		canvas.popdialog(TMBI_GUI1);
}

function tmbi_options_defaults()
{
	if(isfile("base/client/ui/cache/calibri_18.gft"))
		TMBI_Options_val1.setvalue("Calibri");
	else
		TMBI_Options_val1.setvalue("Palatino Linotype");
	tmbi_help(1);
	TMBI_Options_val2.setvalue(160);
	TMBI_Options_val3.setvalue("0.8");
	TMBI_Options_val4.setvalue(1);
	TMBI_Options_Val5.setvalue(0);
	TMBI_Options_val6.setvalue(1);
	TMBI_Options_val7.setvalue(1);
	TMBI_Options_val8.setvalue(5);
	TMBI_Options_val9.setvalue(0);
	TMBI_Options_Val10.setvalue(0);
	$tmbi::colorselector::fullcolor0 = "1 0.4 0 1";
	$tmbi::colorselector::fullcolor1 = "1 1 1 1";
	$tmbi::colorselector::fullcolor2 = "0 0 0 1";
	tmbi_setcolormode($tmbi::colorselector::current);
}

function tmbi_helpabout()
{
	tmbi_helpbox.setvalue("The Too Many Bricks inventory mod is developed by Nexus BL_ID 4833, who is the co-founder of NARG.\n\nYou should visit the NARG forum page in the add-ons section of forum.blockland.us to learn more about the other mods that Nexus and others have developed for the community.");
}

function tmbi_helpinterface()
{
	tmbi_helpbox.setvalue("TMBI does its best to make building more convienent and as intuitive as possible.\n\nYou can use the mousewheel to scroll sideways through rows and hold control while scrolling to go up and down.\n\nIn the brick selector, you can now resize both the selector itself, and the inventory scroll box.\n\nTMBI comes with a ghost brick mover you can bind in control options or TMBI Options.");
}

function tmbi_helptips()
{
	tmbi_helpbox.setvalue("You can keep a row of bricks in your selector without it showing up while building by selecting the hide option next to it.\n\nYou should also poke through the options for interface preferences.\n\nIf you want to load a macro recorded before getting TMBI, you need to turn on the alternate building mode in options.");
}

function tmbi_helpwarnings()
{
	tmbi_helpbox.setvalue("DO NOT TRACE CONSOLE WHILE TMBI IS VERSION CHECKING!  For some reason, this can cause you to crash.  If you must trace while TMBI opens for the first time, you can disable auto version checking in options.\n\nALSO: TMBI disables server dependencies for using the 0-9 keys.  You can re-enable these dependencies in the options if the server requires it, but you will not be able to use them for building.");
}

if($tmbi_executed)
{
	TMBI_GUI1.delete();
	TMBI_GUI2.delete();

	tmbi_scrollbox.delete();
	tmbi_debug("warning: potential problems in this thingy over in here.");
	
}
$tmbi_executed = 1;
exec("./TMBI_GUI1.gui");
exec("./TMBI_GUI2.gui");
tmbi_defaultprefs();
$tmbi::rebindmsg = "This server uses your building keybinds for something other than building.  Your build mode has been changed to allow this (You can use the arrowkeys and mousewheel in your inventory).\n\nIf you want to change back, click no.";
$tmbi::debug = 0; //console spam galore

if(isfile("config/client/tmbi/prefs.cs"))
	exec("config/client/tmbi/prefs.cs");
tmbi_options_cancel();

if($tmbi_bound)
	return;
$tmbi_bound = true;
$remapdivision[$remapcount] = "Too Many Bricks Inventory";
$remapname[$remapcount] = "Toggle Ghost Brick Mover";
$remapcmd[$remapcount] = "tmbi_toggleGhostMover";
$remapcount++;
